
// copytosd: copy file from local filesystem to sd-server 
//
// usage: copytosd device baud localpathfilename sdpathfilename 
//
#include <stdio.h>
#include <stdlib.h>
//
#include "rs232.h"
// 
static int    port = 0;
static int    baudrate = 0;
static int    timeout = 250;
static int    verbose = 1;
static unsigned char buffer[516];
//
// read byte
unsigned char rx_wait(port) {
  int result=-1;
  while(result==-1) {
    result=ReceiveByte(port);
  }
  return (unsigned char)result;
}
//
int getResultSimple() {
  int retval=0;
  int ready=0;
  int bytes=-1;
  int bcount=0;
  unsigned char rxbyte;
  buffer[bcount]=0;
  while(ready==0) {
    if (ready==0) { 
      rxbyte=rx_wait(port);
      if (rxbyte=='E') {
        rxbyte=rx_wait(port);
        if (rxbyte=='R') {
          retval=3;
          bytes=0;
        }
      }
      else {
        if (rxbyte=='O') {
          rxbyte=rx_wait(port);
          if (rxbyte=='K') {
            retval=2;
            bytes=0;
          }
        }
        else {
          if (rxbyte==13) {
            rxbyte=0;
            ready=1;	
          }
          else {
            if (bytes>-1) {
              if ((rxbyte > 47) && (rxbyte < 58)) {
                bytes=(bytes*10) + (rxbyte-48);
              }
            }
          }
        }
      }
    }
  }
  if (retval>0) {
//' result ... bytes in retval
     if (retval==3) {
       retval=-bytes; 
       printf("\nERROR \n");
     }
     else {
       retval=bytes;
     }
     bcount=0;
     if (bytes>0) {
       while(bcount<bytes) {         
         rxbyte=rx_wait(port);
	 buffer[bcount]=rxbyte;
         bcount++;
       }
     }
     buffer[bcount]=0;
  }
  return retval; // -bytes err +bytes count content in buffer 
}


// AR open read AG 512 get
void SDsendCMD(unsigned char File_X,unsigned char Cmd,unsigned char Third) {
  SendByte(port,File_X);
  SendByte(port,Cmd);
  SendByte(port,Third);
}
//
//void SDsendBuf(unsigned char *buf, int size) {
//  SendBuf(port, buf, size);
//}
//
void SDsendStringCR(unsigned char *buf) {
  cprintf(port, buf);
  SendByte(port,13);
}
//
int main(int argc, char **argv) {
  int i;
  int num;
  int err;
  FILE *f;  
  if( argc<4 ) {
    printf("usage: copytosd port baud localpathfilename sdpathfilename \n");
    printf("          port can be:\n");
    for (i = 0; i < ComportCount(); i++) {
         printf("          %s%d = %s\n", (i < 9 ? " " : ""), i + 1, ShortportName(i));
    }
    exit(1);
  }
  sscanf(argv[1], "%d", &port);
  if ((port < 1) || (port > ComportCount())) {
    printf("Error: port must be between 1 and %d\n", ComportCount());
    exit(1);
  }
  port--;
  sscanf(argv[2], "%d", &baudrate);
  if ((baudrate < 50) || (baudrate >921600)) {
    printf("Error: baudrate must be between 1 and %d\n",921600);
    exit(1);
  }
  if (OpenComport(port, baudrate, timeout, verbose)) {
    printf("Error: opening comport\n");
    exit(1);
  }
// open read localfile
  f = fopen(argv[3], "rb");
  if (f == NULL) {
    fprintf(stderr, "Error: Unable to open localfile %s\n", argv[3]);
    CloseComport(port);
    exit(1);
  } else {
// open write propfile
     SDsendCMD('A','W',' ');
    SDsendStringCR(argv[4]);
    err=getResultSimple();
    if (err<0) {
      printf("Error: Unable to open propfile %s\n",argv[4]);
      printf("Error from sd-server:  %s\n",buffer);
      CloseComport(port);
      exit(1);
    } else {
      err=1;
      while (err>0) {
        err = fread(buffer, 1,512, f);
        if (err>0) {
          SDsendCMD('A','P',' '); 
          i=err;
          if (i>99) {
            num=i/100;
            SendByte(port,num+48);
            i=i-(num*100);
          }
          if (i>9) {
            num=i/10;
            SendByte(port,num+48);
            i=i-(num*10);
          }
          SendByte(port,i+48);
          SendByte(port,13);
          SendBuf(port, buffer, err);
          i=getResultSimple();
          if (i<0) {
            printf("Error: writing propfile %s\n",buffer);       
          }
        }
      }
      CloseComport(port);
    }
    fclose(f);
  }
  return 0;
}
