
// lsdirsd: list directory of sdserver
//
// usage: lsdir device baud <sdpathfilename>
//
#include <stdio.h>
#include <stdlib.h>
//
#include "rs232.h"
//
static int    port = 0;
static int    baudrate = 0;
static int    timeout = 250;
static int    verbose = 1;
//
// read byte
unsigned char rx_wait(port) {
  int result=-1;
  while(result==-1) {
    result=ReceiveByte(port);
  }
  return (unsigned char)result;
}
//
int SDoutputResultLine() {
  int retval=0;
  int ready=0;
  int bytes=-1;
  int empty=-1;
  int bcount=0;
  unsigned char rxbyte;
  while(ready==0) {
    if (ready==0) { 
      rxbyte=rx_wait(port);
      if (rxbyte=='E') {
        rxbyte=rx_wait(port);
        if (rxbyte=='R') {
          retval=3;
          bytes=0;
        }
      }
      else {
        if (rxbyte=='O') {
          rxbyte=rx_wait(port);
          if (rxbyte=='K') {
            retval=2;
            bytes=0;
          }
        }
        else {
          if (rxbyte==13) {
            rxbyte=0;
            ready=1;	
          }
          else {
            if (bytes>-1) {
              if ((rxbyte > 47) && (rxbyte < 58)) {
                bytes=(bytes*10) + (rxbyte-48);
              }
            }
          }
        }
      }
    }
  }
  if (retval>0) {
//' result ... bytes in retval ... quick output ... this is very ugly ...
     if (retval==3) {
       retval=-bytes; 
       printf("\nERROR \n");
       empty=1;
     }
     else {
       retval=bytes;
     }
     bcount=0;
     if (bytes>0) {
       while(bcount<bytes) {         
         rxbyte=rx_wait(port);
         if (bcount<8) {
           if (rxbyte!=32) {
             empty=0;
           }
         }
         printf("%c",rxbyte);
         bcount++;
       }
       if (retval<bytes) {
         empty=1;
       }
       if (bytes==1) {
         empty=-1;
       }
     }
     printf("\n"); 
  }
  return empty;
}


// AB open AM next/more
void SDsendCMD(unsigned char File_X,unsigned char Cmd,unsigned char Third) {
  SendByte(port,File_X);
  SendByte(port,Cmd);
  SendByte(port,Third);
}
//
void SDsendStringCR(unsigned char *buf) {
  cprintf(port, buf);
  SendByte(port,13);
}
//
int main(int argc, char **argv) {
  int i;  
  if( argc<3 ) {
    printf("usage: lsdirsd port baud sdpathfilename\n");
    printf("          port can be:\n");
    for (i = 0; i < ComportCount(); i++) {
         printf("          %s%d = %s\n", (i < 9 ? " " : ""), i + 1, ShortportName(i));
    }
    exit(1);
  }
  sscanf(argv[1], "%d", &port);
  if ((port < 1) || (port > ComportCount())) {
    printf("Error: port must be between 1 and %d\n", ComportCount());
    exit(1);
  }
  port--;
  sscanf(argv[2], "%d", &baudrate);
  if ((baudrate < 50) || (baudrate >921600)) {
    printf("Error: baudrate must be between 1 and %d\n",921600);
    exit(1);
  }
  if (OpenComport(port, baudrate, timeout, verbose)) {
    printf("Error: opening comport\n");
    exit(1);
  }
//    printf("waitforkey\n");
//getchar();
  SDsendCMD('A','B',' ');
  SDsendStringCR(argv[3]);
  i=SDoutputResultLine();
  if (i<1) {
    i=0;
    while(i==0) {
      SDsendCMD('A','M',13);
      i=SDoutputResultLine();
    }
  }
  CloseComport(port);
  return 0;
}
